//
// PlatelistsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class PlatelistsAPI {
    /**
     Add plate to the list

     - parameter platelistId: (path)  
     - parameter plateId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func addPlateListPlate(platelistId: Int, plateId: Int, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        addPlateListPlateWithRequestBuilder(platelistId: platelistId, plateId: plateId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Add plate to the list
     - POST /api/v1/platelists/{platelist_id}/plates/{plate_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter platelistId: (path)  
     - parameter plateId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func addPlateListPlateWithRequestBuilder(platelistId: Int, plateId: Int) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/platelists/{platelist_id}/plates/{plate_id}"
        let platelistIdPreEscape = "\(platelistId)"
        let platelistIdPostEscape = platelistIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{platelist_id}", with: platelistIdPostEscape, options: .literal, range: nil)
        let plateIdPreEscape = "\(plateId)"
        let plateIdPostEscape = plateIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{plate_id}", with: plateIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Create new plate list

     - parameter body: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func createPlateList(body: PlateListCreate, completion: @escaping ((_ data: PlateListGet?,_ error: Error?) -> Void)) {
        createPlateListWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Create new plate list
     - POST /api/v1/platelists

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "name" : "name",
  "description" : "description",
  "id" : 0,
  "priority" : "low",
  "plate_count" : 6
}}]
     - parameter body: (body)  

     - returns: RequestBuilder<PlateListGet> 
     */
    open class func createPlateListWithRequestBuilder(body: PlateListCreate) -> RequestBuilder<PlateListGet> {
        let path = "/api/v1/platelists"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<PlateListGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Delete specified plate list

     - parameter platelistId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func deletePlateList(platelistId: Int, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        deletePlateListWithRequestBuilder(platelistId: platelistId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Delete specified plate list
     - DELETE /api/v1/platelists/{platelist_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter platelistId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func deletePlateListWithRequestBuilder(platelistId: Int) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/platelists/{platelist_id}"
        let platelistIdPreEscape = "\(platelistId)"
        let platelistIdPostEscape = platelistIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{platelist_id}", with: platelistIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get plate list with provided ID

     - parameter platelistId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getPlateList(platelistId: Int, completion: @escaping ((_ data: PlateListGet?,_ error: Error?) -> Void)) {
        getPlateListWithRequestBuilder(platelistId: platelistId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get plate list with provided ID
     - GET /api/v1/platelists/{platelist_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "name" : "name",
  "description" : "description",
  "id" : 0,
  "priority" : "low",
  "plate_count" : 6
}}]
     - parameter platelistId: (path)  

     - returns: RequestBuilder<PlateListGet> 
     */
    open class func getPlateListWithRequestBuilder(platelistId: Int) -> RequestBuilder<PlateListGet> {
        var path = "/api/v1/platelists/{platelist_id}"
        let platelistIdPreEscape = "\(platelistId)"
        let platelistIdPostEscape = platelistIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{platelist_id}", with: platelistIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<PlateListGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get plates of the list

     - parameter platelistId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getPlateListPlates(platelistId: Int, completion: @escaping ((_ data: PlateGetList?,_ error: Error?) -> Void)) {
        getPlateListPlatesWithRequestBuilder(platelistId: platelistId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get plates of the list
     - GET /api/v1/platelists/{platelist_id}/plates

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "plates" : [ {
    "owner_full_name" : "owner_full_name",
    "number" : "number",
    "car_manufacturer" : "car_manufacturer",
    "car_model" : "car_model",
    "car_image_url" : "http://example.com/aeiou",
    "owner_birth_date" : "2000-01-23",
    "owner_document_number" : "owner_document_number",
    "car_manufacture_date" : "2000-01-23",
    "car_color" : "car_color",
    "id" : 0,
    "car_image_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "car_type" : "car_type"
  }, {
    "owner_full_name" : "owner_full_name",
    "number" : "number",
    "car_manufacturer" : "car_manufacturer",
    "car_model" : "car_model",
    "car_image_url" : "http://example.com/aeiou",
    "owner_birth_date" : "2000-01-23",
    "owner_document_number" : "owner_document_number",
    "car_manufacture_date" : "2000-01-23",
    "car_color" : "car_color",
    "id" : 0,
    "car_image_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "car_type" : "car_type"
  } ]
}}]
     - parameter platelistId: (path)  

     - returns: RequestBuilder<PlateGetList> 
     */
    open class func getPlateListPlatesWithRequestBuilder(platelistId: Int) -> RequestBuilder<PlateGetList> {
        var path = "/api/v1/platelists/{platelist_id}/plates"
        let platelistIdPreEscape = "\(platelistId)"
        let platelistIdPostEscape = platelistIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{platelist_id}", with: platelistIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<PlateGetList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get all plate lists, optionally filtered by name

     - parameter name: (query)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getPlateLists(name: String? = nil, completion: @escaping ((_ data: PlateListList?,_ error: Error?) -> Void)) {
        getPlateListsWithRequestBuilder(name: name).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get all plate lists, optionally filtered by name
     - GET /api/v1/platelists

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "platelists" : [ {
    "name" : "name",
    "description" : "description",
    "id" : 0,
    "priority" : "low",
    "plate_count" : 6
  }, {
    "name" : "name",
    "description" : "description",
    "id" : 0,
    "priority" : "low",
    "plate_count" : 6
  } ]
}}]
     - parameter name: (query)  (optional)

     - returns: RequestBuilder<PlateListList> 
     */
    open class func getPlateListsWithRequestBuilder(name: String? = nil) -> RequestBuilder<PlateListList> {
        let path = "/api/v1/platelists"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "name": name
        ])


        let requestBuilder: RequestBuilder<PlateListList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Remove plate from the list

     - parameter platelistId: (path)  
     - parameter plateId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func removePlateListPlate(platelistId: Int, plateId: Int, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        removePlateListPlateWithRequestBuilder(platelistId: platelistId, plateId: plateId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Remove plate from the list
     - DELETE /api/v1/platelists/{platelist_id}/plates/{plate_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter platelistId: (path)  
     - parameter plateId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func removePlateListPlateWithRequestBuilder(platelistId: Int, plateId: Int) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/platelists/{platelist_id}/plates/{plate_id}"
        let platelistIdPreEscape = "\(platelistId)"
        let platelistIdPostEscape = platelistIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{platelist_id}", with: platelistIdPostEscape, options: .literal, range: nil)
        let plateIdPreEscape = "\(plateId)"
        let plateIdPostEscape = plateIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{plate_id}", with: plateIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Update plate list with provided ID

     - parameter body: (body)  
     - parameter platelistId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updatePlateList(body: PlateList, platelistId: Int, completion: @escaping ((_ data: PlateListGet?,_ error: Error?) -> Void)) {
        updatePlateListWithRequestBuilder(body: body, platelistId: platelistId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update plate list with provided ID
     - PUT /api/v1/platelists/{platelist_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "name" : "name",
  "description" : "description",
  "id" : 0,
  "priority" : "low",
  "plate_count" : 6
}}]
     - parameter body: (body)  
     - parameter platelistId: (path)  

     - returns: RequestBuilder<PlateListGet> 
     */
    open class func updatePlateListWithRequestBuilder(body: PlateList, platelistId: Int) -> RequestBuilder<PlateListGet> {
        var path = "/api/v1/platelists/{platelist_id}"
        let platelistIdPreEscape = "\(platelistId)"
        let platelistIdPostEscape = platelistIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{platelist_id}", with: platelistIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<PlateListGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
}
